<template>
  <div class="kyc-content">
    <template v-if="!!user.email">
      <div id="idensic" v-if="user.is_deposited"></div>
      <div v-else class="kyc-message">
        <p>{{ $t('kyc.message') }}</p>
        <button type="button" @click="$router.push('/deposit')">{{ $t('kyc.btn_deposit') }}</button>
      </div>
    </template>
  </div>
</template>
<script>
import { mapState, mapMutations } from 'vuex';
import rf from '../../common/requests/RequestFactory';

export default {
  methods: {
    ...mapMutations([
      'updateUser'
    ]),
    async initIdCheck () {
      const token = await rf.getRequest('UserKycRequest').getSumSubToken();
      const result = await rf.getRequest('UserKycRequest').getApplicant();
      const applicant = result.data;

      let config = {
        accessToken: token.data,
        applicantDataPage: {
          enabled: true,
          fields: [
            {
              name: 'firstName',
              required: true
            },
            {
              name: 'lastName',
              required: true
            }
          ]
        },
        requiredDocuments: 'IDENTITY:ID_CARD,PASSPORT,DRIVERS;SELFIE:SELFIE;PROOF_OF_RESIDENCE:UTILITY_BILL'
      };

      if (applicant) {
        config = {
          accessToken: token.data,
          applicantId: applicant.applicant_id
        };
      }
      const self = this;
      window.idensic.init(
        '#idensic',
        config,
        function (messageType, payload) {
          if (messageType === 'idCheck.onApplicantCreated' && !applicant) {
            const params = {
              user_id: self.user.id,
              applicant_id: payload.applicantId,
            };

            rf.getRequest('UserKycRequest').create(params);
          } else if (messageType === 'idCheck.onApplicantSubmitted' || messageType === 'idCheck.onApplicantResubmitted') {
            rf.getRequest('UserRequest').updateUserInfoAfterKyc()
              .then(res => {
                self.updateUser(res.data);
              });
          }
        }
      );
    },
  },
  computed: {
    ...mapState([
      'user',
    ]),
  },
  watch: {
    user: {
      handler: function(val, oldVal) {
        if (!!val && _.isEmpty(oldVal)) {
          this.isFetched = true;

          if (val.is_deposited) {
            this.initIdCheck();
          }
        }
      },
      immediate: true
    }
  },
};
</script>

<style lang="scss" scoped>
  @import '../../../sass/_variables.scss';

  #idensic {
    background: white;
  }
  * {
    font-family: $font-family-home;
  }
  .kyc-content {
    min-height: calc(100vh - 320px);
    height: auto;
    background: white;
    .kyc-message {
      text-align: center;
      p {
        margin-top: 75px;
        font-size: 20px;
        font-weight: normal;
        font-style: normal;
        font-stretch: normal;
        line-height: 1.5;
        letter-spacing: normal;
        color: #505050;
      }
      button {
        margin-top: 23px;
        width: 135px;
        height: 40px;
        border-radius: 30px;
        background-color: #fa7300;
        border: solid 1px #fa7300;
        font-size: 14px;
        font-weight: bold;
        font-style: normal;
        font-stretch: normal;
        line-height: normal;
        letter-spacing: 1.1px;
        text-align: center;
        color: #ffffff;
        cursor: pointer;
        outline: none;
      }
    }
  }
</style>
